VERSION 5.00
Begin VB.UserControl FilterPicture 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1320
   ScaleHeight     =   1200
   ScaleWidth      =   1320
   ToolboxBitmap   =   "FiltPic.ctx":0000
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   360
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   120
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   855
   End
End
Attribute VB_Name = "FilterPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Picture filter control"
Option Explicit

' Enumerated values.
Enum filtpic_Kernel
    Custom_filtpic_Kernel
    Average_filtpic_Kernel
    Low_Pass_1_filtpic_Kernel
    Low_Pass_2_filtpic_Kernel
    Low_Pass_3_filtpic_Kernel
    High_Pass_1_filtpic_Kernel
    High_Pass_2_filtpic_Kernel
    High_Pass_3_filtpic_Kernel
    Prewitt_N_filtpic_Kernel
    Prewitt_NE_filtpic_Kernel
    Prewitt_E_filtpic_Kernel
    Prewitt_SE_filtpic_Kernel
    Prewitt_S_filtpic_Kernel
    Prewitt_SW_filtpic_Kernel
    Prewitt_W_filtpic_Kernel
    Prewitt_NW_filtpic_Kernel
    Laplacian_1_filtpic_Kernel
    Laplacian_2_filtpic_Kernel
End Enum

'Default Property Values:
Const m_def_StandardFilter = 0
Const m_def_FilterValue = 1
Const m_def_FilterWeight = 9
Const m_def_MaxFilterIndex = 1
'Property Variables:
Dim m_StandardFilter As Integer
Dim m_FilterValue() As Single
Dim m_FilterWeight As Single
Dim m_MaxFilterIndex As Integer
Public Sub ApplyFilter()
Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bits_per_pixel As Integer
Dim wid As Long
Dim hgt As Long
Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single

    ' Get the picture's bitmap.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    wid = UBound(old_pixels, 1) + 1
    hgt = UBound(old_pixels, 2) + 1
    ReDim new_pixels(0 To wid - 1, 0 To hgt - 1)

    ' Apply the filter.
    For i = 1 To wid - 2
        For j = 1 To hgt - 2
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -1 To 1
                For n = -1 To 1
                    With old_pixels(i + m, j + n)
                        totr = totr + m_FilterValue(m, n) * .rgbRed
                        totg = totg + m_FilterValue(m, n) * .rgbGreen
                        totb = totb + m_FilterValue(m, n) * .rgbBlue
                    End With
                Next n
            Next m
            totr = CInt(totr / m_FilterWeight)
            totg = CInt(totg / m_FilterWeight)
            totb = CInt(totb / m_FilterWeight)
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            If totr > 255 Then totr = 255
            If totg > 255 Then totg = 255
            If totb > 255 Then totb = 255
            With new_pixels(i, j)
                .rgbRed = totr
                .rgbGreen = totg
                .rgbBlue = totb
            End With
        Next j
        DoEvents
    Next i
    
    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture
    UserControl.Picture = UserControl.Image
End Sub

' Set a normal weight for the filter.
Private Sub SetNormalFilterWeight()
Dim i As Integer
Dim j As Integer
Dim wgt As Integer

    For i = -m_MaxFilterIndex To m_MaxFilterIndex
        For j = -m_MaxFilterIndex To m_MaxFilterIndex
            wgt = wgt + m_FilterValue(i, j)
        Next j
    Next i
    m_FilterWeight = wgt
End Sub

' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Picture = OrigPict.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set OrigPict.Picture = New_Picture
    
    ' Display the new picture.
    Set UserControl.Picture = New_Picture
    UserControl_Resize
    
    PropertyChanged "Picture"
End Property

Public Property Get MaxFilterIndex() As Integer
Attribute MaxFilterIndex.VB_Description = "The size of the filter."
    MaxFilterIndex = m_MaxFilterIndex
End Property

Public Property Let MaxFilterIndex(ByVal New_MaxFilterIndex As Integer)
Dim i As Integer
Dim j As Integer

    ' Make sure it's at least 0.
    If New_MaxFilterIndex < 0 Then New_MaxFilterIndex = 0
    
    m_MaxFilterIndex = New_MaxFilterIndex
    
    ' Reinitialize the kernel.
    ReDim m_FilterValue(-m_MaxFilterIndex To m_MaxFilterIndex, -m_MaxFilterIndex To m_MaxFilterIndex)
    For i = -m_MaxFilterIndex To m_MaxFilterIndex
        For j = -m_MaxFilterIndex To m_MaxFilterIndex
            m_FilterValue(i, j) = m_def_FilterValue
        Next j
    Next i
    
    m_StandardFilter = Custom_filtpic_Kernel
    PropertyChanged "StandardFilter"
    PropertyChanged "MaxFilterIndex"
End Property
Public Sub EightBitColorApplyFilter()
Attribute EightBitColorApplyFilter.VB_Description = "Applies the filter to the picture."
Dim bm As BITMAP
Dim hbm As Long
Dim old_bytes() As Byte
Dim new_bytes() As Byte
Dim hpal As Long
Dim wid As Long
Dim hgt As Long
Dim palentry(0 To 255) As PALETTEENTRY

Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single
Dim r As Integer
Dim g As Integer
Dim b As Integer

    ' Get the picture's bitmap.
    hbm = OrigPict.Image
    GetObject hbm, Len(bm), bm
    wid = bm.bmWidthBytes
    hgt = bm.bmHeight
    ReDim old_bytes(0 To wid - 1, 0 To hgt - 1)
    ReDim new_bytes(0 To wid - 1, 0 To hgt - 1)
    GetBitmapBits hbm, wid * hgt, old_bytes(0, 0)
    
    ' Get the picture's palette entries.
    hpal = OrigPict.Picture.hpal
    RealizePalette OrigPict.hdc
    GetSystemPaletteEntries OrigPict.hdc, 0, 256, palentry(0)
    ResizePalette hpal, 256
    ResizePalette UserControl.Picture.hpal, 256
    SetPaletteEntries hpal, 0, 256, palentry(0)
    SetPaletteEntries UserControl.Picture.hpal, 0, 256, palentry(0)

    ' Apply the filter.
    For i = m_MaxFilterIndex To OrigPict.ScaleWidth - 1 - m_MaxFilterIndex
        For j = m_MaxFilterIndex To OrigPict.ScaleHeight - 1 - m_MaxFilterIndex
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -m_MaxFilterIndex To m_MaxFilterIndex
                For n = -m_MaxFilterIndex To m_MaxFilterIndex
                    With palentry(old_bytes(i + m, j + n))
                        totr = totr + m_FilterValue(m, n) * .peRed
                        totg = totg + m_FilterValue(m, n) * .peGreen
                        totb = totb + m_FilterValue(m, n) * .peBlue
                    End With
                Next n
            Next m
            totr = CInt(totr / m_FilterWeight)
            totg = CInt(totg / m_FilterWeight)
            totb = CInt(totb / m_FilterWeight)
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            new_bytes(i, j) = _
                GetNearestPaletteIndex(hpal, _
                    RGB(totr, totg, totb) + _
                    &H2000000)
        Next j
        DoEvents
    Next i
    
    ' Update the bitmap.
    SetBitmapBits UserControl.Image, _
        wid * hgt, new_bytes(0, 0)
    UserControl.Refresh
End Sub

Private Sub OrigPict_Resize()
    picNew.Width = OrigPict.Width
    picNew.Height = OrigPict.Height
End Sub


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
Dim i As Integer
Dim j As Integer

    m_MaxFilterIndex = m_def_MaxFilterIndex
    m_FilterWeight = m_def_FilterWeight
    
    ' Initialize the kernel.
    ReDim m_FilterValue(-m_MaxFilterIndex To m_MaxFilterIndex, -m_MaxFilterIndex To m_MaxFilterIndex)
    For i = -m_MaxFilterIndex To m_MaxFilterIndex
        For j = -m_MaxFilterIndex To m_MaxFilterIndex
            m_FilterValue(i, j) = m_def_FilterValue
        Next j
    Next i
    m_StandardFilter = m_def_StandardFilter
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim i As Integer
Dim j As Integer

    Set OrigPict.Picture = PropBag.ReadProperty("OrigPict", Nothing)
    Set UserControl.Picture = PropBag.ReadProperty("Picture", Nothing)
    m_MaxFilterIndex = PropBag.ReadProperty("MaxFilterIndex", m_def_MaxFilterIndex)
    m_FilterWeight = PropBag.ReadProperty("FilterWeight", m_def_FilterWeight)
    
    ReDim m_FilterValue(-m_MaxFilterIndex To m_MaxFilterIndex, -m_MaxFilterIndex To m_MaxFilterIndex)
    For i = -m_MaxFilterIndex To m_MaxFilterIndex
        For j = -m_MaxFilterIndex To m_MaxFilterIndex
            m_FilterValue(i, j) = PropBag.ReadProperty("FilterValue" & Format$(i) & "_" & Format$(j), 1)
        Next j
    Next i
    
    m_StandardFilter = PropBag.ReadProperty("StandardFilter", m_def_StandardFilter)
End Sub
Private Sub UserControl_Resize()
Static resizing As Boolean

    ' Do not recurse.
    If resizing Then Exit Sub
    
    If OrigPict.Picture <> 0 Then
        resizing = True
        Size OrigPict.Width, OrigPict.Height
        resizing = False
    End If
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Dim i As Integer
Dim j As Integer

    Call PropBag.WriteProperty("OrigPict", OrigPict.Picture, Nothing)
    Call PropBag.WriteProperty("Picture", UserControl.Picture, Nothing)
    Call PropBag.WriteProperty("MaxFilterIndex", m_MaxFilterIndex, m_def_MaxFilterIndex)
    Call PropBag.WriteProperty("FilterWeight", m_FilterWeight, m_def_FilterWeight)

    For i = -m_MaxFilterIndex To m_MaxFilterIndex
        For j = -m_MaxFilterIndex To m_MaxFilterIndex
            Call PropBag.WriteProperty("FilterValue" & Format$(i) & "_" & Format$(j), m_FilterValue(i, j), 1)
        Next j
    Next i
    
    Call PropBag.WriteProperty("StandardFilter", m_StandardFilter, m_def_StandardFilter)
End Sub

Public Property Get FilterValue(ByVal i As Integer, ByVal j As Integer) As Single
Attribute FilterValue.VB_Description = "An entry in the filter's kernel."
    If i < -m_MaxFilterIndex Or _
       i > m_MaxFilterIndex Or _
       j < -m_MaxFilterIndex Or _
       j > m_MaxFilterIndex _
    Then
        FilterValue = -1
    Else
        FilterValue = m_FilterValue(i, j)
    End If
End Property
Public Property Let FilterValue(ByVal i As Integer, ByVal j As Integer, ByVal New_FilterValue As Single)
    If i < -m_MaxFilterIndex Or _
       i > m_MaxFilterIndex Or _
       j < -m_MaxFilterIndex Or _
       j > m_MaxFilterIndex _
    Then
        Exit Property
    End If
    
    m_FilterValue(i, j) = New_FilterValue
    
    StandardFilter = Custom_filtpic_Kernel
    PropertyChanged "FilterValue"
End Property
Public Property Get FilterWeight() As Single
Attribute FilterWeight.VB_Description = "The total weight of the kernel."
    FilterWeight = m_FilterWeight
End Property

Public Property Let FilterWeight(ByVal New_FilterWeight As Single)
    m_FilterWeight = New_FilterWeight
    StandardFilter = Custom_filtpic_Kernel
    PropertyChanged "FilterWeight"
End Property

Public Property Get StandardFilter() As filtpic_Kernel
Attribute StandardFilter.VB_Description = "Selects a standard filter."
    StandardFilter = m_StandardFilter
End Property

Public Property Let StandardFilter(ByVal New_StandardFilter As filtpic_Kernel)
Dim i As Integer
Dim j As Integer

    Select Case New_StandardFilter
        Case Average_filtpic_Kernel
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            SetNormalFilterWeight

        Case Low_Pass_1_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            m_FilterValue(0, 0) = 2
            SetNormalFilterWeight

        Case Low_Pass_2_filtpic_Kernel
            MaxFilterIndex = 1
            m_FilterValue(-1, -1) = 1
            m_FilterValue(1, -1) = 1
            m_FilterValue(-1, 1) = 1
            m_FilterValue(1, 1) = 1
            m_FilterValue(-1, 0) = 2
            m_FilterValue(0, -1) = 2
            m_FilterValue(1, 0) = 2
            m_FilterValue(0, 1) = 2
            m_FilterValue(0, 0) = 4
            SetNormalFilterWeight

        Case Low_Pass_3_filtpic_Kernel
            MaxFilterIndex = 2
            m_FilterValue(-2, -2) = 1
            m_FilterValue(-2, -1) = 2
            m_FilterValue(-2, 0) = 3
            m_FilterValue(-2, 1) = 2
            m_FilterValue(-2, 2) = 1
            m_FilterValue(-1, -2) = 2
            m_FilterValue(-1, -1) = 4
            m_FilterValue(-1, 0) = 6
            m_FilterValue(-1, 1) = 4
            m_FilterValue(-1, 2) = 2
            m_FilterValue(0, -2) = 3
            m_FilterValue(0, -1) = 6
            m_FilterValue(0, 0) = 9
            m_FilterValue(0, 1) = 6
            m_FilterValue(0, 2) = 3
            m_FilterValue(1, -2) = 2
            m_FilterValue(1, -1) = 4
            m_FilterValue(1, 0) = 6
            m_FilterValue(1, 1) = 4
            m_FilterValue(1, 2) = 2
            m_FilterValue(2, -2) = 1
            m_FilterValue(2, -1) = 2
            m_FilterValue(2, 0) = 3
            m_FilterValue(2, 1) = 2
            m_FilterValue(2, 2) = 1
            SetNormalFilterWeight

        Case High_Pass_1_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = -1
                Next j
            Next i
            m_FilterValue(0, 0) = 12
            SetNormalFilterWeight

        Case High_Pass_2_filtpic_Kernel
            MaxFilterIndex = 1
            m_FilterValue(-1, -1) = 0
            m_FilterValue(1, -1) = 0
            m_FilterValue(-1, 1) = 0
            m_FilterValue(1, 1) = 0
            m_FilterValue(-1, 0) = -1
            m_FilterValue(0, -1) = -1
            m_FilterValue(1, 0) = -1
            m_FilterValue(0, 1) = -1
            m_FilterValue(0, 0) = 5
            SetNormalFilterWeight

        Case High_Pass_3_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = -1
                Next j
            Next i
            m_FilterValue(0, 0) = 9
            SetNormalFilterWeight

        Case Prewitt_N_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                m_FilterValue(i, -1) = -1
            Next i
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_NE_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            m_FilterValue(1, 0) = -1
            m_FilterValue(1, -1) = -1
            m_FilterValue(0, -1) = -1
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_E_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            For j = -m_MaxFilterIndex To m_MaxFilterIndex
                m_FilterValue(1, j) = -1
            Next j
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_SE_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            m_FilterValue(1, 0) = -1
            m_FilterValue(1, 1) = -1
            m_FilterValue(0, 1) = -1
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_S_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                m_FilterValue(i, 1) = -1
            Next i
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_SW_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            m_FilterValue(-1, 0) = -1
            m_FilterValue(-1, 1) = -1
            m_FilterValue(0, 1) = -1
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_W_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            For j = -m_MaxFilterIndex To m_MaxFilterIndex
                m_FilterValue(-1, j) = -1
            Next j
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Prewitt_NW_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = 1
                Next j
            Next i
            m_FilterValue(-1, 0) = -1
            m_FilterValue(-1, -1) = -1
            m_FilterValue(0, -1) = -1
            m_FilterValue(0, 0) = -2
            m_FilterWeight = 1

        Case Laplacian_1_filtpic_Kernel
            MaxFilterIndex = 1
            m_FilterValue(-1, -1) = 0
            m_FilterValue(1, -1) = 0
            m_FilterValue(-1, 1) = 0
            m_FilterValue(1, 1) = 0
            m_FilterValue(-1, 0) = -1
            m_FilterValue(0, -1) = -1
            m_FilterValue(1, 0) = -1
            m_FilterValue(0, 1) = -1
            m_FilterValue(0, 0) = 4
            m_FilterWeight = 1

        Case Laplacian_2_filtpic_Kernel
            MaxFilterIndex = 1
            For i = -m_MaxFilterIndex To m_MaxFilterIndex
                For j = -m_MaxFilterIndex To m_MaxFilterIndex
                    m_FilterValue(i, j) = -1
                Next j
            Next i
            m_FilterValue(0, 0) = 8
            m_FilterWeight = 1
    End Select
    
    m_StandardFilter = New_StandardFilter
    
    If m_StandardFilter <> Custom_filtpic_Kernel Then
        PropertyChanged "StandardFilter"
        PropertyChanged "FilterValue"
    End If
    PropertyChanged "FilterWeight"
End Property
