VERSION 5.00
Begin VB.UserControl PictureSizer 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1995
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2325
   ScaleHeight     =   133
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   155
   ToolboxBitmap   =   "PicSizer.ctx":0000
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1215
      Left            =   960
      ScaleHeight     =   81
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   1
      Top             =   720
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1215
      Left            =   240
      ScaleHeight     =   81
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   0
      Top             =   240
      Visible         =   0   'False
      Width           =   1215
   End
End
Attribute VB_Name = "PictureSizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Picture sizer control"
Option Explicit

'Event Declarations:
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user double clicks on the picture."
Event Click()
Attribute Click.VB_Description = "Occurs when the user clicks on the picture."
'Default Property Values:
Const m_def_ScaleFactor = 1#
'Property Variables:
Dim m_ScaleFactor As Single
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

' *********************************************
' Return the nearest non-static palette netry.
' *********************************************
Private Function GetNearestNonStatic(pal() As PALETTEENTRY, r As Integer, g As Integer, b As Integer) As Integer
Dim best_d2 As Long
Dim best_i As Integer
Dim d2 As Long
Dim i As Integer
Dim dr As Long
Dim dg As Long
Dim db As Long

    With pal(10)
        dr = r - .peRed
        dg = g - .peGreen
        db = b - .peBlue
    End With
    best_d2 = dr * dr + dg * dg + db * db
    best_i = 10
    For i = 11 To 245
        With pal(i)
            dr = r - .peRed
            dg = g - .peGreen
            db = b - .peBlue
        End With
        d2 = dr * dr + dg * dg + db * db
        If d2 < best_d2 Then
            best_i = i
            best_d2 = d2
        End If
    Next i
    GetNearestNonStatic = best_i
End Function
' *********************************************
' Create the resized picture.
' *********************************************
Private Sub EightBitColorMakePicture()
Dim bm As BITMAP
Dim hbm As Long
Dim old_bytes() As Byte
Dim new_bytes() As Byte
Dim hpal As Long
Dim oldwid As Long
Dim oldhgt As Long
Dim newwid As Long
Dim newhgt As Long
Dim pal(0 To 255) As PALETTEENTRY

Dim cx As Single
Dim cy As Single
Dim tx As Integer
Dim ty As Integer
Dim fx As Single
Dim fy As Single
Dim ifx As Integer
Dim ify As Integer
Dim dx As Single
Dim dy As Single
Dim i As Integer
Dim r(1 To 4) As Integer
Dim g(1 To 4) As Integer
Dim b(1 To 4) As Integer
Dim yoff As Single
    
    ' Get the picture's palette entries.
    RealizePalette OrigPict.hdc
    hpal = OrigPict.Picture.hpal
    GetSystemPaletteEntries OrigPict.hdc, 0, 256, pal(0)
    ResizePalette hpal, 256
    ResizePalette UserControl.Picture.hpal, 256
    SetPaletteEntries hpal, 0, 256, pal(0)
    SetPaletteEntries UserControl.Picture.hpal, 0, 256, pal(0)
    
    ' Get the picture's bitmap.
    hbm = OrigPict.Image
    GetObject hbm, Len(bm), bm
    oldwid = bm.bmWidthBytes
    oldhgt = bm.bmHeight
    ReDim old_bytes(0 To oldwid - 1, 0 To oldhgt - 1)
    GetBitmapBits hbm, oldwid * oldhgt, old_bytes(0, 0)
    newwid = m_ScaleFactor * oldwid
    newhgt = m_ScaleFactor * oldhgt
    
    ' Make UserControl the right size.
    UserControl.ScaleMode = vbPixels
    Size ScaleX(newwid, vbPixels, vbTwips), _
         ScaleY(newhgt, vbPixels, vbTwips)
    
    ' Erase UserControl.
    Line (0, 0)-(newwid, newhgt), BackColor, BF
    UserControl.Picture = UserControl.Image
    
    ' See how big the control's bitmap is.
    GetObject UserControl.Image, Len(bm), bm
    newwid = bm.bmWidthBytes
    newhgt = bm.bmHeight
    ReDim new_bytes(0 To newwid - 1, 0 To newhgt - 1)

    ' Find OrigPict's center.
    OrigPict.ScaleMode = vbPixels
    cx = (OrigPict.ScaleWidth - 1) \ 2
    cy = (OrigPict.ScaleHeight - 1) \ 2
    
    ' Perform the sizing.
    For tx = 0 To newwid - 1
        fx = tx / m_ScaleFactor
        For ty = 0 To newhgt - 1
            fy = ty / m_ScaleFactor

            ' Skip it if any of the four nearest
            ' source pixels lie outside OrigPict.
            ifx = Int(fx)
            ify = Int(fy)
            If ifx > 0 And ifx < oldwid - 1 And _
               ify > 0 And ify < oldhgt - 1 _
            Then
                ' Interpolate using the four nearest
                ' pixels in OrigPict.
                With pal(old_bytes(ifx, ify))
                    r(1) = .peRed
                    g(1) = .peGreen
                    b(1) = .peBlue
                End With
                With pal(old_bytes(ifx + 1, ify))
                    r(2) = .peRed
                    g(2) = .peGreen
                    b(2) = .peBlue
                End With
                With pal(old_bytes(ifx, ify + 1))
                    r(3) = .peRed
                    g(3) = .peGreen
                    b(3) = .peBlue
                End With
                With pal(old_bytes(ifx + 1, ify + 1))
                    r(4) = .peRed
                    g(4) = .peGreen
                    b(4) = .peBlue
                End With
                
                ' Interpolate in the Y direction.
                dy = fy - ify
                dx = fx - ifx
                r(1) = r(1) * (1 - dy) + r(3) * dy
                g(1) = g(1) * (1 - dy) + g(3) * dy
                b(1) = b(1) * (1 - dy) + b(3) * dy
                
                r(2) = r(2) * (1 - dy) + r(4) * dy
                g(2) = g(2) * (1 - dy) + g(4) * dy
                b(2) = b(2) * (1 - dy) + b(4) * dy
                
                ' Interpolate the results in the X direction.
                r(1) = r(1) * (1 - dx) + r(2) * dx
                g(1) = g(1) * (1 - dx) + g(2) * dx
                b(1) = b(1) * (1 - dx) + b(2) * dx
                
                ' Set the point.
                new_bytes(tx, ty) = _
                    GetNearestPaletteIndex( _
                        hpal, _
                        RGB(r(1), g(1), b(1)) + _
                        &H2000000)
                If new_bytes(tx, ty) < 10 Or _
                   new_bytes(tx, ty) > 245 _
                Then
                    new_bytes(tx, ty) = _
                        GetNearestNonStatic(pal(), _
                            r(1), g(1), b(1))
                End If
            End If
        Next ty
    Next tx

    ' Update the bitmap.
    SetBitmapBits UserControl.Image, _
        newwid * newhgt, new_bytes(0, 0)
    UserControl.Refresh

    ' Make the image permanent.
    UserControl.Picture = UserControl.Image
End Sub
' *********************************************
' Create the resized picture.
' *********************************************
Private Sub MakePicture()
Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bits_per_pixel As Integer
Dim oldwid As Long
Dim oldhgt As Long
Dim newwid As Long
Dim newhgt As Long

Dim cx As Single
Dim cy As Single
Dim tx As Integer
Dim ty As Integer
Dim fx As Single
Dim fy As Single
Dim ifx As Integer
Dim ify As Integer
Dim dx As Single
Dim dy As Single
Dim i As Integer
Dim r(1 To 4) As Integer
Dim g(1 To 4) As Integer
Dim b(1 To 4) As Integer
Dim yoff As Single

    ' Get the picture's bitmap.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    oldwid = UBound(old_pixels, 1) + 1
    oldhgt = UBound(old_pixels, 2) + 1
    newwid = m_ScaleFactor * oldwid
    newhgt = m_ScaleFactor * oldhgt

    ' Make UserControl the right size.
    Size ScaleX(newwid, vbPixels, vbTwips), _
         ScaleY(newhgt, vbPixels, vbTwips)
    picNew.Width = ScaleWidth
    picNew.Height = ScaleHeight

    ' Erase UserControl.
    Line (0, 0)-(newwid, newhgt), BackColor, BF
    UserControl.Picture = UserControl.Image
    
    ' Make room for the new image.
    ReDim new_pixels(0 To newwid - 1, 0 To newhgt - 1)

    ' Find OrigPict's center.
    cx = (OrigPict.ScaleWidth - 1) \ 2
    cy = (OrigPict.ScaleHeight - 1) \ 2

    ' Perform the sizing.
    For tx = 0 To newwid - 1
        fx = tx / m_ScaleFactor
        For ty = 0 To newhgt - 1
            fy = ty / m_ScaleFactor

            ' Skip it if any of the four nearest
            ' source pixels lie outside OrigPict.
            ifx = Int(fx)
            ify = Int(fy)
            If ifx > 0 And ifx < oldwid - 1 And _
               ify > 0 And ify < oldhgt - 1 _
            Then
                ' Interpolate using the four nearest
                ' pixels in OrigPict.
                With old_pixels(ifx, ify)
                    r(1) = .rgbRed
                    g(1) = .rgbGreen
                    b(1) = .rgbBlue
                End With
                With old_pixels(ifx + 1, ify)
                    r(2) = .rgbRed
                    g(2) = .rgbGreen
                    b(2) = .rgbBlue
                End With
                With old_pixels(ifx, ify + 1)
                    r(3) = .rgbRed
                    g(3) = .rgbGreen
                    b(3) = .rgbBlue
                End With
                With old_pixels(ifx + 1, ify + 1)
                    r(4) = .rgbRed
                    g(4) = .rgbGreen
                    b(4) = .rgbBlue
                End With

                ' Interpolate in the Y direction.
                dy = fy - ify
                dx = fx - ifx
                r(1) = r(1) * (1 - dy) + r(3) * dy
                g(1) = g(1) * (1 - dy) + g(3) * dy
                b(1) = b(1) * (1 - dy) + b(3) * dy
                
                r(2) = r(2) * (1 - dy) + r(4) * dy
                g(2) = g(2) * (1 - dy) + g(4) * dy
                b(2) = b(2) * (1 - dy) + b(4) * dy
                
                ' Interpolate the results in the X direction.
                r(1) = r(1) * (1 - dx) + r(2) * dx
                g(1) = g(1) * (1 - dx) + g(2) * dx
                b(1) = b(1) * (1 - dx) + b(2) * dx
                
                ' Set the point.
                With new_pixels(tx, ty)
                    .rgbRed = r(1)
                    .rgbGreen = g(1)
                    .rgbBlue = b(1)
                End With
            End If
        Next ty
    Next tx

    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture
    UserControl.Picture = UserControl.Image
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Picture = OrigPict.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set OrigPict.Picture = New_Picture
    Set UserControl.Picture = New_Picture
    PropertyChanged "Picture"

    MakePicture
End Property
' *********************************************
' Break the color into components.
' *********************************************
Private Sub UnRGB(clr As OLE_COLOR, r As Integer, g As Integer, b As Integer)
    r = clr Mod 256
    g = (clr \ 256) Mod 256
    b = clr \ 65536
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub


'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    Set OrigPict.Picture = PropBag.ReadProperty("Picture", Nothing)
    Set UserControl.Picture = PropBag.ReadProperty("SizedImage", Nothing)
    m_ScaleFactor = PropBag.ReadProperty("Scale", m_def_ScaleFactor)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Picture", OrigPict.Picture, Nothing)
    Call PropBag.WriteProperty("SizedImage", UserControl.Picture, Nothing)
    Call PropBag.WriteProperty("Scale", m_ScaleFactor, m_def_ScaleFactor)
End Sub
Public Property Get SizedImage() As Picture
Attribute SizedImage.VB_Description = "Returns the resized picture."
Attribute SizedImage.VB_MemberFlags = "400"
    Set SizedImage = UserControl.Picture
End Property

Public Property Set SizedImage(ByVal New_SizedImage As Picture)
    If Ambient.UserMode = False Then Err.Raise 383
    If Ambient.UserMode Then Err.Raise 382
    Set UserControl.Picture = New_SizedImage
    PropertyChanged "SizedImage"
End Property
Public Property Get ScaleFactor() As Single
Attribute ScaleFactor.VB_Description = "The factor by which the picture should be enlarged or shrunk."
    ScaleFactor = m_ScaleFactor
End Property

Public Property Let ScaleFactor(ByVal New_ScaleFactor As Single)
    If New_ScaleFactor < 0.01 Then New_ScaleFactor = 0.01
    m_ScaleFactor = New_ScaleFactor
    PropertyChanged "ScaleFactor"

    MakePicture
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_ScaleFactor = m_def_ScaleFactor
End Sub

