VERSION 5.00
Begin VB.UserControl RotatedPicture 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1995
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2325
   ScaleHeight     =   133
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   155
   ToolboxBitmap   =   "RotPic.ctx":0000
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1215
      Left            =   840
      ScaleHeight     =   81
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   1
      Top             =   600
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1215
      Left            =   240
      ScaleHeight     =   81
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   0
      Top             =   240
      Visible         =   0   'False
      Width           =   1215
   End
End
Attribute VB_Name = "RotatedPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Rotated picture control"
Option Explicit

' Enumerated values.
Enum rotpic_BorderStyle
    None_rotpic_BorderStyle = 0
    Normal_rotpic_BorderStyle = 1
    Rotated_rotpic_BorderStyle
End Enum

'Default Property Values:
Const m_def_BorderStyle = 0
Const m_def_Angle = 0
'Property Variables:
Dim m_BorderStyle As Integer
Dim m_Angle As Single
'Event Declarations:
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."

Dim skip_redraw As Boolean

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

Public Property Get BorderStyle() As rotpic_BorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As rotpic_BorderStyle)
    m_BorderStyle = New_BorderStyle
    If m_BorderStyle <> Rotated_rotpic_BorderStyle Then
        UserControl.BorderStyle = m_BorderStyle
    End If
    PropertyChanged "BorderStyle"
End Property
' *********************************************
' Create the rotated picture.
' *********************************************
Private Sub MakePicture()
Const PI = 3.14159

Dim fx1 As Integer ' (fx1, fy1)-(fx2, fy2)
Dim fy1 As Integer ' bound the original picture.
Dim fx2 As Integer
Dim fy2 As Integer
Dim tx1 As Integer ' (tx1, ty1)-(tx2, ty2)
Dim ty1 As Integer ' bound the new picture.
Dim tx2 As Integer
Dim ty2 As Integer
Dim cfx As Integer ' (cfx, cfy) is the center
Dim cfy As Integer ' of the original picture.
Dim ctx As Integer ' (ctx, cty) is the center
Dim cty As Integer ' of the new picture.

Dim theta As Single     ' The angle.
Dim ctheta As Single    ' Sin(theta)
Dim stheta As Single    ' Cos(theta)
Dim ptx(1 To 4) As Single
Dim pty(1 To 4) As Single
Dim tmp As Single
Dim i As Integer
Dim oldhgt As Integer
Dim oldwid As Integer
Dim newhgt As Integer
Dim newwid As Integer
Dim fx As Single
Dim fy As Single
Dim tx As Single
Dim ty As Single
Dim ifx As Integer
Dim ify As Integer
Dim clr As OLE_COLOR
Dim dx As Single
Dim dy As Single
Dim r1 As Integer
Dim g1 As Integer
Dim b1 As Integer
Dim r2 As Integer
Dim g2 As Integer
Dim b2 As Integer
Dim r3 As Integer
Dim g3 As Integer
Dim b3 As Integer
Dim r4 As Integer
Dim g4 As Integer
Dim b4 As Integer
Dim bg_color As RGBTriplet
Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bits_per_pixel As Integer

    ' Do nothing if we're loading.
    If skip_redraw Then Exit Sub
    
    theta = PI * m_Angle / 180#
    stheta = Sin(theta)
    ctheta = Cos(theta)
    
    ' Find the bounding box.
    oldwid = OrigPict.ScaleWidth
    oldhgt = OrigPict.ScaleHeight
    fx1 = 0
    fx2 = oldwid - 1
    fy1 = 0
    fy2 = oldhgt - 1
    cfx = (fx1 + fx2) / 2
    cfy = (fy1 + fy2) / 2
    ptx(1) = fx1
    ptx(2) = fx2
    ptx(3) = fx2
    ptx(4) = fx1
    pty(1) = fy1
    pty(2) = fy1
    pty(3) = fy2
    pty(4) = fy2
    
    ' Translate the bounding box to (0, 0).
    For i = 1 To 4
        ptx(i) = ptx(i) - cfx
        pty(i) = pty(i) - cfy
    Next i
    
    ' Rotate the bounding box.
    For i = 1 To 4
        tmp = ptx(i) * ctheta + pty(i) * stheta
        pty(i) = -ptx(i) * stheta + pty(i) * ctheta
        ptx(i) = tmp
    Next i
    
    ' Find the bounds for the new picture.
    tx1 = ptx(1)
    tx2 = tx1
    ty1 = pty(1)
    ty2 = ty1
    For i = 1 To 4
        If tx1 > ptx(i) Then tx1 = ptx(i)
        If tx2 < ptx(i) Then tx2 = ptx(i)
        If ty1 > pty(i) Then ty1 = pty(i)
        If ty2 < pty(i) Then ty2 = pty(i)
    Next i
    
    ' Translate the new bounds.
    For i = 1 To 4
        ptx(i) = ptx(i) - tx1
        pty(i) = pty(i) - ty1
    Next i
    tx2 = tx2 - tx1
    tx1 = 0
    ty2 = ty2 - ty1
    ty1 = 0
    
    ' Find the new center.
    ctx = (tx1 + tx2) / 2
    cty = (ty1 + ty2) / 2
    
    ' Resize the control to fit.
    newwid = tx2 - tx1 + 1
    newhgt = ty2 - ty1 + 1
    Size ScaleX(newwid, vbPixels, vbTwips), _
         ScaleY(newhgt, vbPixels, vbTwips)
    picNew.Width = newwid
    picNew.Height = newhgt

    ' Blank the control.
    Line (0, 0)-(newwid, newhgt), BackColor, BF

    ' Get the original picture's pixels.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    ReDim new_pixels(0 To newwid - 1, 0 To newhgt - 1)

    ' Get the background color.
    UnRGB UserControl.BackColor(), r1, g1, b1
    With bg_color
        .rgbRed = r1
        .rgbGreen = g1
        .rgbBlue = b1
    End With

    ' Transform the points.
    For ty = ty1 To ty2
        For tx = tx1 To tx2
            ' Find the location (fx, fy) that maps
            ' to the pixel (tx, ty).
            fx = (tx - ctx) * ctheta - (ty - cty) * stheta + cfx
            fy = (tx - ctx) * stheta + (ty - cty) * ctheta + cfy

            ' Skip it if any of the four nearest
            ' source pixels lie outside the
            ' allowed source area.
            ify = Int(fy)
            ifx = Int(fx)
            If ifx >= fx1 And ifx < fx2 And _
               ify >= fy1 And ify < fy2 _
            Then
                ' Interpolate using the four nearest
                ' pixels in from_pic.
                dy = fy - ify
                dx = fx - ifx

                ' Get the color values.
                With old_pixels(ifx, ify)
                    r1 = .rgbRed
                    g1 = .rgbGreen
                    b1 = .rgbBlue
                End With
                With old_pixels(ifx + 1, ify)
                    r2 = .rgbRed
                    g2 = .rgbGreen
                    b2 = .rgbBlue
                End With
                With old_pixels(ifx, ify + 1)
                    r3 = .rgbRed
                    g3 = .rgbGreen
                    b3 = .rgbBlue
                End With
                With old_pixels(ifx + 1, ify + 1)
                    r4 = .rgbRed
                    g4 = .rgbGreen
                    b4 = .rgbBlue
                End With

                ' Interpolate in the Y direction.
                r1 = r1 * (1 - dy) + r3 * dy
                r2 = r2 * (1 - dy) + r4 * dy
                g1 = g1 * (1 - dy) + g3 * dy
                g2 = g2 * (1 - dy) + g4 * dy
                b1 = b1 * (1 - dy) + b3 * dy
                b2 = b2 * (1 - dy) + b4 * dy
                
                ' Interpolate the results in the X direction.
                r1 = r1 * (1 - dx) + r2 * dx
                g1 = g1 * (1 - dx) + g2 * dx
                b1 = b1 * (1 - dx) + b2 * dx
                
                ' Set the point.
                With new_pixels(tx, ty)
                    .rgbRed = r1
                    .rgbGreen = g1
                    .rgbBlue = b1
                End With
            Else
                new_pixels(tx, ty) = bg_color
            End If
        Next tx
        DoEvents
    Next ty

    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture

    ' Display the rotated bounding box
    ' if desired.
    If m_BorderStyle = Rotated_rotpic_BorderStyle Then
        CurrentX = ptx(4)
        CurrentY = pty(4)
        For i = 1 To 4
            Line -(ptx(i), pty(i))
        Next i
    End If
    
    ' Make the image permanent.
    UserControl.Picture = UserControl.Image
End Sub
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Picture = OrigPict.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set OrigPict.Picture = New_Picture
    PropertyChanged "Picture"
        
    MakePicture
End Property
Public Property Get Angle() As Single
Attribute Angle.VB_Description = "The angle by which the picture should be rotated in degrees."
    Angle = m_Angle
End Property

Public Property Let Angle(ByVal New_Angle As Single)
    m_Angle = New_Angle
    PropertyChanged "Angle"
End Property

' *********************************************
' Break the color into components.
' *********************************************
Private Sub UnRGB(clr As OLE_COLOR, r As Integer, g As Integer, b As Integer)
    r = clr Mod 256
    g = (clr \ 256) Mod 256
    b = clr \ 65536
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    skip_redraw = True
    
    m_BorderStyle = m_def_BorderStyle
    m_Angle = m_def_Angle

    If m_BorderStyle <> Rotated_rotpic_BorderStyle Then
        UserControl.BorderStyle = m_BorderStyle
    End If
    
    skip_redraw = False
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    skip_redraw = True
    
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    m_Angle = PropBag.ReadProperty("Angle", m_def_Angle)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    Set UserControl.Picture = PropBag.ReadProperty("RotatedImage", Nothing)

    If m_BorderStyle <> Rotated_rotpic_BorderStyle Then
        UserControl.BorderStyle = m_BorderStyle
    End If
    
    skip_redraw = False
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Angle", m_Angle, m_def_Angle)
    Call PropBag.WriteProperty("Picture", Picture, Nothing)
    Call PropBag.WriteProperty("RotatedImage", UserControl.Picture, Nothing)
End Sub
Public Property Get RotatedImage() As Picture
Attribute RotatedImage.VB_Description = "The rotated picture."
Attribute RotatedImage.VB_MemberFlags = "400"
    Set RotatedImage = UserControl.Picture
End Property

Public Property Set RotatedImage(ByVal New_RotatedImage As Picture)
    If Ambient.UserMode = False Then Err.Raise 383
    If Ambient.UserMode Then Err.Raise 382
    Set UserControl.Picture = New_RotatedImage
    PropertyChanged "RotatedImage"
End Property

