VERSION 5.00
Begin VB.UserControl UnsharpMask 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1320
   ScaleHeight     =   1200
   ScaleWidth      =   1320
   ToolboxBitmap   =   "Unsharp.ctx":0000
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   360
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   120
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   855
   End
End
Attribute VB_Name = "UnsharpMask"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Unsharp masking picture control"
Option Explicit

'Default Property Values:
Const m_def_MaxFilterIndex = 1
'Property Variables:
Dim m_MaxFilterIndex As Integer
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Picture = OrigPict.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set OrigPict.Picture = New_Picture
    
    ' Display the new picture.
    Set UserControl.Picture = New_Picture
    UserControl_Resize
    
    PropertyChanged "Picture"
End Property

Public Property Get MaxFilterIndex() As Integer
    MaxFilterIndex = m_MaxFilterIndex
End Property

Public Property Let MaxFilterIndex(ByVal New_MaxFilterIndex As Integer)
Attribute MaxFilterIndex.VB_Description = "The size of the filter. This should be odd."
    ' Make sure it's at least 0.
    If New_MaxFilterIndex < 0 Then New_MaxFilterIndex = 0
    m_MaxFilterIndex = New_MaxFilterIndex
    PropertyChanged "MaxFilterIndex"
End Property
Public Sub ApplyFilter()
Attribute ApplyFilter.VB_Description = "Applies the filter to the picture."
Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bits_per_pixel As Integer
Dim wid As Long
Dim hgt As Long

Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single
Dim r As Integer
Dim g As Integer
Dim b As Integer
Dim kernel() As Single
Dim wgt As Single
Dim num As Integer
Dim start As Integer

    ' Get the picture's bitmap.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    wid = UBound(old_pixels, 1) + 1
    hgt = UBound(old_pixels, 2) + 1
    ReDim new_pixels(0 To wid - 1, 0 To hgt - 1)

    ' Create a simple weighted averaging filter.
    ReDim kernel(-m_MaxFilterIndex To m_MaxFilterIndex, -m_MaxFilterIndex To m_MaxFilterIndex)
    wgt = 0
    start = 1
    For i = -m_MaxFilterIndex To m_MaxFilterIndex
        num = start
        For j = -m_MaxFilterIndex To m_MaxFilterIndex
            kernel(i, j) = num
            wgt = wgt + num
            If j < 0 Then
                num = num + start
            Else
                num = num - start
            End If
        Next j
        If i < 0 Then
            start = start + 1
        Else
            start = start - 1
        End If
    Next i
    
    ' Apply the filter.
    For i = m_MaxFilterIndex To OrigPict.ScaleWidth - 1 - m_MaxFilterIndex
        For j = m_MaxFilterIndex To OrigPict.ScaleHeight - 1 - m_MaxFilterIndex
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -m_MaxFilterIndex To m_MaxFilterIndex
                For n = -m_MaxFilterIndex To m_MaxFilterIndex
                    With old_pixels(i + m, j + n)
                        totr = totr + kernel(m, n) * .rgbRed
                        totg = totg + kernel(m, n) * .rgbGreen
                        totb = totb + kernel(m, n) * .rgbBlue
                    End With
                Next n
            Next m
            With old_pixels(i, j)
                totr = 2 * .rgbRed - CInt(totr / wgt)
                totg = 2 * .rgbGreen - CInt(totg / wgt)
                totb = 2 * .rgbBlue - CInt(totb / wgt)
            End With
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            If totr > 255 Then totr = 255
            If totg > 255 Then totg = 255
            If totb > 255 Then totb = 255
            With new_pixels(i, j)
                .rgbRed = totr
                .rgbGreen = totg
                .rgbBlue = totb
            End With
        Next j
        DoEvents
    Next i

    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture
    UserControl.Picture = UserControl.Image
End Sub

Private Sub OrigPict_Resize()
    picNew.Width = OrigPict.Width
    picNew.Height = OrigPict.Height
End Sub


Private Sub UserControl_InitProperties()
    m_MaxFilterIndex = m_def_MaxFilterIndex
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set OrigPict.Picture = PropBag.ReadProperty("OrigPict", Nothing)
    Set UserControl.Picture = PropBag.ReadProperty("Picture", Nothing)
    m_MaxFilterIndex = PropBag.ReadProperty("MaxFilterIndex", m_def_MaxFilterIndex)
End Sub
Private Sub UserControl_Resize()
Static resizing As Boolean

    ' Do not recurse.
    If resizing Then Exit Sub
    
    If OrigPict.Picture <> 0 Then
        resizing = True
        Size OrigPict.Width, OrigPict.Height
        resizing = False
    End If
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("OrigPict", OrigPict.Picture, Nothing)
    Call PropBag.WriteProperty("Picture", UserControl.Picture, Nothing)
    Call PropBag.WriteProperty("MaxFilterIndex", m_MaxFilterIndex, m_def_MaxFilterIndex)
End Sub
